Subject: [U-Boot] [RFC] Kbuild support for ARM FIT images

From: [email-masked] (Rob Herring)
Date: Thu, 21 Feb 2013 18:19:05 -0600

On 02/21/2013 05:28 PM, Jason Gunthorpe wrote:
> On Fri, Feb 22, 2013 at 12:18:48AM +0100, Wolfgang Denk wrote:
> 
>>> The DT is meant to describe hardware.  As far as I know, the hardware I 
>>> own seems to be rather static and stable, and unlike software there is 
>>> no way I can change it (soldering irons don't count).
>>
>> There is other hardware available (for example FPGA based) where this
>> does not apply.
> 
> Agreed.. We do that here as well, the DT is also used to describe the
> functionality inside FPGA(s). We do things like declare a GPIO
> controller inside the FPGA, then stack the bitbang MDIO/I2C on top of
> that, then declare a bunch of devices on those busses. DT makes this
> extremely straightforward.
> 
> However, it is critical that the DT, kernel and FPGA are matched
> together - we always arrange things so that the DTB, kernel and FPGA
> config are bundled together and update atomically during firmware
> upgrade.
> 
> Xilinx's Zynq is a great example of this kind of stuff, FWIW. IIRC
> Xilinx has a DT generator from their IP tools, so you can literally go
> into their design software, configure the hardware IP blocks, and get
> back a FPGA config and a DT to go with it.
> 

The desired FPGA use case is DT updates after booting the kernel. This
has nothing to do with FIT images. And if the FPGA tools generate the
DTB, then it is certainly not tied to the kernel.

Rob